<?php

class actionStatusiCatEdit extends cmsAction {

    public function run($id) {
        if (!$id) {cmsCore::error404();}
        $model = cmsCore::getModel('statusi');
        $form = $this->getForm('cat', array('edit'));
        $is_submitted = $this->request->has('submit');
		$model->filterEqual('id', $id);
        $cats = $model->getCats($id);
		foreach ($cats as $ct) {$cat['title'] = $ct['title'];}	

        if ($is_submitted) {
            $cat = $form->parse($this->request, $is_submitted);
            $errors = $form->validate($this, $cat);
            if (!$errors) {
                $model->updateCat($id, $cat);
                $this->redirectToAction('cats');
            } else {
                cmsUser::addSessionMessage(LANG_FORM_ERRORS, 'error');
            }
        }

        return cmsTemplate::getInstance()->render('backend/cat_add', array(
            'do' => 'edit',
            'cat' => $cat,
            'form' => $form,
            'errors' => isset($errors) ? $errors : false
        ));

    }
}