<?php

class actionStatusiStatusAdd extends cmsAction {

    public function run($id = FALSE) {
        $model = cmsCore::getModel('statusi');
        $form = $this->getForm('status', array('add', $id));
        $is_submitted = $this->request->has('submit');
        if ($is_submitted) {

            $status = $form->parse($this->request, $is_submitted);
            $errors = $form->validate($this, $status);

            if (!$errors) {
                $status_id = $model->addStatus($status);
                if ($status_id) {
                    cmsUser::addSessionMessage('Статус успешно добавлен!!!', 'success');
                }
                $this->redirectToAction('statusi');
            } else {
                cmsUser::addSessionMessage(LANG_FORM_ERRORS, 'error');
            }
        }

        return cmsTemplate::getInstance()->render('backend/status', array(
            'do' => 'add',
            'cat_id' => $id,
            'form' => $form,
            'errors' => isset($errors) ? $errors : false
        ));
    }
}