<?php
class statusi extends cmsFrontend {

	protected $useOptions = true;
    
    public function actionIndex() {
        $template = cmsTemplate::getInstance();
		$perpage = $this->options['perpage'];
		$comments = $this->options['comments'];
        $show_cat = $this->options['show_cat'];
		if($show_cat) {
		$this->model->selectOnly('c.id as id, COUNT(i.id) AS summ, c.title');
		$this->model->joinInner('statusi_cats', 'c', 'c.id = i.cat_id');
        $this->model->groupBy('cat_id');
		$this->model->orderBy('c.ordering', 'ASC');
        $cats = $this->model->getStatusi();
		$this->model->resetFilters();
		}
        $page = $this->request->get('page', 1);
        $this->model->orderBy('id', 'DESC')->limitPage($page, $perpage);
        $this->model->select('i.id AS sid, i.text, i.installs, u.nickname, u.avatar');
        $this->model->joinInner('users', 'u', 'i.author = u.id');
        $statusi = $this->model->getStatusi();
        $total = $this->model->getStatusiCount();
        $template->render('main', array(
            'statusi' => $statusi,
            'cats' => $cats,
            'show_cat' => $show_cat,
            'total' => $total,
            'page' => $page,
            'perpage' => $perpage,
            'comments' => $comments
        ));
    }
    
    public function actionView($cat_id=FALSE) {
        if(!$cat_id) {cmsCore::error404();}
        $template = cmsTemplate::getInstance();
        $perpage = $this->options['perpage'];
		$comments = $this->options['comments'];
        $page = $this->request->get('page', 1);
        $this->model->orderBy('id', 'DESC')->limitPage($page, $perpage);
        $this->model->select('i.id AS sid, i.text, i.installs, u.nickname, u.avatar, c.title as cat_title');
        $this->model->joinInner('users', 'u', 'i.author = u.id');
        $this->model->joinInner('statusi_cats', 'c', 'i.cat_id = c.id');
        $statusi = $this->model->getStatusi($cat_id);
        $total = $this->model->getStatusiCount($cat_id);
        foreach ($statusi as $sts) { $cat_title = $sts['cat_title']; } 
        $template->render('main', array(
            'statusi' => $statusi,
            'cats' => $cats,
            'title' => $cat_title,
            'total' => $total,
            'page' => $page,
            'perpage' => $perpage,
            'comments' => $comments
        ));
    }
    
    public function actionRead($id=FALSE){
        if(!$id) {cmsCore::error404();}
        $template = cmsTemplate::getInstance();
		$share = $this->options['share'];
        $this->model->select('i.id AS sid, i.text, i.installs, u.nickname, u.avatar, c.title as cat_title');
        $this->model->joinInner('users', 'u', 'i.author = u.id');
        $this->model->joinInner('statusi_cats', 'c', 'i.cat_id = c.id');
        $this->model->limit('1');
        $statusi = $this->model->getStatusi($cat_id=FALSE, $id);
        foreach ($statusi as $sts) { $cat_title = $sts['cat_title']; } 
        
		if($this->options['comments']) {
			$comments_controller = cmsCore::getController('comments', new cmsRequest(array(
				'target_controller' => $this->name,
				'target_subject' => $this->name,
				'target_id' => $id
			), cmsRequest::CTX_INTERNAL));
			$comments_widget = $comments_controller->getWidget();
		}
        
        $template->render('read', array(
            'statusi' => $statusi,
            'title' => $cat_title,
            'comments_widget' => $comments_widget,
			'share' => $share
        ));
    }
    
    public function actionInstall(){
        if (!$this->request->isAjax()){ cmsCore::error404(); }
        $id = $this->request->get('id');
        $install = $this->request->get('install');
        $install = $install + 1;
        $this->model->updateInstall($id, $install);
        echo $install;
        $this->halt();
    }
	
	public function actionAdd() {
		$is_can_add = cmsUser::isAdmin() || cmsUser::isAllowed('statusi', 'add');
		if (!$is_can_add){ cmsCore::error404(); }
		$template = cmsTemplate::getInstance();
		$user = cmsUser::getInstance();
		$form = $this->getForm('add');
		$is_submitted = $this->request->get('submit');
		$status = $form->parse($this->request, $is_submitted);
		$errors = false;
		if($is_submitted){
		 $errors = $form->validate($this, $status);
		 if(!$errors) {
			$status['author'] = $user->id;
			$status_id = $this->model->addStatus($status);
			if($status_id) {
				cmsUser::addSessionMessage('Статус успешно добавлен!!!', 'success');
			}
			$this->redirectToAction('read', array($status_id));
		 }
		 if($errors) {
			 cmsUser::addSessionMessage('Ошибки в форме', 'error');
		 }
		}
		$template->render('add', array(
			'do' => 'add',
			'form' => $form,
			'status' => $status,
			'errors' => $errors
		));
     }
	 
	public function actionEdit($id=FALSE) {
	
		if (!$id) { cmsCore::error404(); }
		
		$statusi = $this->model->getStatusi($cat_id=FALSE, $id);
		
		if (!$statusi) { cmsCore::error404(); }
		
		$status = array();
		
		foreach ($statusi as $sts) { $status = $sts; } 
		
		$user = cmsUser::getInstance();
	
		$is_can_edit = $user->is_admin ||
					cmsUser::isAllowed('statusi', 'edit', 'all') ||
					(cmsUser::isAllowed('statusi', 'edit', 'own') && $status['author']==$user->id);	
		
		if (!$is_can_edit) { cmsCore::error404(); }
		
		$errors = false;
		
		$form = $this->getForm('edit');
		
		$is_submitted = $this->request->has('submit');				
		
		if ($is_submitted){
			
			$status = $form->parse($this->request, $is_submitted);
			
			$errors = $form->validate($this, $status);
			
			if (!$errors){
				$this->model->updateStatus($id, $status);
				cmsUser::addSessionMessage('Статус успешно изменен!!!', 'success');
				$this->redirectToAction('read', array($id));
			}
			
			if ($errors){
				cmsUser::addSessionMessage(LANG_FORM_ERRORS, 'error');
			}
			
		}
		
		$template = cmsTemplate::getInstance();
		
		$template->render('add', array(
			'do' => 'edit',
			'form' => $form,
			'errors' => $errors,
			'status' => $status
		));
	}
	
	public function actionDelete($id=false){
		
		if (!$id) { cmsCore::error404(); }
		
		$statusi = $this->model->getStatusi($cat_id=FALSE, $id);
		
		if (!$statusi) { cmsCore::error404(); }
		
		$status = array();
		
		foreach ($statusi as $sts) { $status = $sts; } 
		
		$user = cmsUser::getInstance();
	
		$is_can_del = $user->is_admin ||
					cmsUser::isAllowed('statusi', 'delete', 'all') ||
					(cmsUser::isAllowed('statusi', 'delete', 'own') && $status['author']==$user->id);	
		
		if (!$is_can_del) { cmsCore::error404(); }
		
		$this->model->deleteStatus($id);
		cmsUser::addSessionMessage('Статус успешно удален!!!', 'success');
		$this->redirectToAction('');

	}
	 
	public function actionEditcat($cat_id=FALSE) {
        
		$template = cmsTemplate::getInstance();
		$user = cmsUser::getInstance();
		if(!$user->is_admin) { cmsCore::error404(); }

		$form = $this->getForm('editcat');
		$is_submitted = $this->request->get('submit');
		$cats = $form->parse($this->request, $is_submitted);
		$errors = false;
		if($is_submitted){
		 $errors = $form->validate($this, $cats);
		 if(!$errors) {
			 $cat_id = $this->model->editStatusCat($cats);
			 $this->redirectToAction('editcat');
		 }
		 if($errors) {
			 cmsUser::addSessionMessage('Ошибки в форме', 'error');
		 }
		}
		$template->render('editcat', array(
		 'form' => $form,
		 'cats' => $cats,
		 'errors' => $errors
		));
     }
    
}
