<?php

class modelStatusi extends cmsModel {
    
    public function getStatusi($cat_id=FALSE, $id=FALSE){
        if($cat_id) {$this->filterEqual('cat_id', $cat_id);}
        if($id) {$this->filterEqual('id', $id);}
        return $this->get('statusi');
    }
    
    public function getStatusiCount($cat_id=FALSE){
        if($cat_id) {$this->filterEqual('cat_id', $cat_id);}
        return $this->getCount('statusi');
    }
	
	public function addCat($cat = FALSE) {
        if (!cmsUser::isAdmin() || !$cat) return false;
        $cat['ordering'] = $this->getNextOrdering('statusi_cats');
        return $this->insert('statusi_cats', $cat);
    }
    
    public function getCats(){
        return $this->get('statusi_cats');
    }
	
	public function updateCat($id, $data){        
        return $this->update('statusi_cats', $id, $data);
    }
	
	public function reorderCats($items) {
        $this->reorderByList('statusi_cats', $items);
        return true;
    }
	
    
    public function updateInstall($id, $install){        
        return $this->update('statusi', $id, array('installs' => $install));
    }
	
	public function addStatus($data){        
        return $this->insert('statusi', $data);
    }    
	
	public function updateStatus($id, $data){        
        return $this->update('statusi', $id, $data);
    }
	
	public function deleteStatus($id){
		cmsCore::getModel('comments')->deleteComments('statusi', 'statusi', $id);
		return $this->delete('statusi', $id);	
    }
	
	public function deleteCat($id){
		$items = $this->getStatusi($id);
        if ($items){foreach($items as $item){$this->deleteStatus($item['id']);}}
		return $this->delete('statusi_cats', $id);	
    }
	
    public function updateCommentsCount($ctype_name, $id, $comments_count){
        $this->update('statusi', $id, array('comments' => $comments_count));
        return true;
    }
	
    public function getTargetItemInfo($ctype_name, $id){
        if (!$id){ return false; }
        return array(
            'url' => '/statusi/read/'.$id,
            'title' => 'Статус #'.$id
        );

    }
    
}